import java.applet.*;
import java.awt.*;
import java.math.*;
import java.util.*;

public class dynseis extends Applet {
 class TPointArray {
  Vector L,T,A;
  public TPointArray () {
   L=new Vector();
   T=new Vector();
   A=new Vector();
  }
  public void Add (double l,double t,double a) {
   L.addElement (Double.toString(l));
   T.addElement (Double.toString(t));
   A.addElement (Double.toString(a));
  }
  public double getL (int n) {
   if (n<0 || n>length()-1) return 0;
   return Double.valueOf(L.elementAt(n).toString()).doubleValue();
  }
  public double getT (int n) {
  if (n<0 || n>length()-1) return 0;
   return Double.valueOf(T.elementAt(n).toString()).doubleValue();
  }
  public double getA (int n) {
   if (n<0 || n>length()-1) return 0;
   return Double.valueOf(A.elementAt(n).toString()).doubleValue();
  }
  public int length () {
   return L.size();
  }
 }

 class Tnu {
  double o,p;
  public Tnu () { o=p=0; }
 }

 class THeadBIN {
  int [] F4,F2;
  public THeadBIN () {
   F4 = new int [3];
   F2 = new int [194];
  }
 }
/*
 class THeadTRS {
  int[] F41,F21,F42,F22,F43,F23;
  public THeadTRS () {
   F41 = new int [7];
   F21 = new int [4];
   F42 = new int [8];
   F22 = new int [2];
   F43 = new int [4];
   F23 = new int [76];
  }
 }

 class TTitles {
  THeadTRS[] E;
  public TTitles (int k) {
   E=new THeadTRS [k];
   for (int i=0; i<k; i++) {
    E[i]=new THeadTRS ();
   }
  }
 }
*/
 class TTrase {
  double []f;
  public TTrase (int l) {
   f=new double [l];
  }
  public int high () {
   return f.length;
  }
 }

 class TSgm {
  TTrase [] t;
  public TSgm (int traces) {
   t=new TTrase [traces];
  }
  public int high() {
   return t.length;
  }
 }

 class Frame1 extends Frame {
  Panel pImPanel;
  Graphics Im;
  Dimension DimIm;
  public Frame1 (String s) {
   super (s);
   setResizable (true);
   pImPanel = new Panel ();
   add (pImPanel);
  }
  public boolean handleEvent(Event e) {
   if (e.id == Event.WINDOW_DESTROY) {
    System.out.println ("handleEvent if");//!!!
    setVisible(false);     //hide ();
    return true;
   }
   if (e.id == Event.MOUSE_ENTER) {
    paint (getGraphics()); return true;
   }
   else return false; //super.handleEvent(e);
  }
  public void show () {
   System.out.println ("show");//!!!
   super.show ();
   //setVisible(true);
   Im = pImPanel.getGraphics();
   setDimIm();
   pImPanel.setBackground(Color.white);
   pImPanel.setForeground(Color.black);
  }
  public void setSize (int w,int h) {
   super.setSize (w,h);
   DimIm = pImPanel.getSize();
  }
  public void clearIm () {
   System.out.println ("clearIm");//!!!
   Im.setColor(Color.white);
   Im.clearRect (0,0,DimIm.width-1, DimIm.height-1);
   Im.setColor(Color.black);
   Im.drawRect (0,0,DimIm.width-1, DimIm.height-1);
  }
  public void update (Graphics g) {
   System.out.println ("update");//!!!
   super.paint(getGraphics());
   //Im.create (0,0,DimIm.width,DimIm.height);
   PlotMdl();  PlotSgm();
  }
  public void paint (Graphics g) {
   update (getGraphics());
  }
  public void destroy () {
   Im.dispose ();
  }
  public Graphics Im () {
   return Im;
  }
  public Dimension DimIm () {
   return DimIm;
  }
  public void setDimIm () {
   DimIm = pImPanel.getSize();
  }
 }

 Panel pLeftPanel,pLeft2Panel,pParametersPanel,pSignalPanel,pUDPanel,pRightPanel,pRightPanel1,pRightPanel2;
 Button UDUpButton,UDDownButton,lb_xUpButton,lb_xDownButton,lb_tUpButton,lb_tDownButton,OKButton;
 Label Label1,Label2,Label3,Label4,UDLabel,lb_xLabel,lb_tLabel,MdlLabel,ErrorLabel;
 TextField le_kbEdit,le_dxEdit,le_kppEdit,le_dtEdit;
 Checkbox chb_ARU,chb_fill,chb_SURF,chb_RL,chb_RR,chb_COG;
 TextArea Mdl;
 Graphics Iw;
 Dimension DimIw;
 Font defaultFont,canvasFont;
 Frame1 ff;

 int le_kpv = 101;//!!!

 int
  amp=10,
  strs=10,
  UDPosition=1,
  F,kdt,kpp,kpv,kb,HMS,WM,WS,
  ns=420,
  nt=50,
  sct=1,
  kex=3;
  double
   Zmax,Lmax,Tmax,Vmmax,dx,dt,dts;
  boolean
   auto=false,
   SUN=true,
   SU=false,
   NF=false;
  String [] HT = new String [40];
  THeadBIN HB = new THeadBIN ();
  TPointArray G;
  TSgm D;
  TTrase W;
  //TTitles E;
  Tnu [] Ko;

 public String getAppletInfo() {
  return "DynSeis Java Applet. v.1.0 (C) pers@mail.ru";
 }

 public void init() {
  System.out.println ("init");//!!!
  setLayout(new GridLayout(1,2,4,4));
  setBackground(Color.white);
  setForeground(Color.black);

  pLeftPanel = new Panel();
  pLeftPanel.setLayout (new GridLayout (2,1,4,4));

  pParametersPanel = new Panel();
  pParametersPanel.setLayout (new GridLayout (4,2,4,4));
  Label1=new Label ("  ");  le_kbEdit=new TextField ("1",4);
  Label2=new Label ("   ()");  le_dxEdit=new TextField ("50",4);
  Label3=new Label ("- ");  le_kppEdit=new TextField ("75",4);
  Label4=new Label ("  ()");  le_dtEdit=new TextField ("2",4);
  pParametersPanel.add(Label1);  pParametersPanel.add(le_kbEdit);
  pParametersPanel.add(Label2);  pParametersPanel.add(le_dxEdit);
  pParametersPanel.add(Label3);  pParametersPanel.add(le_kppEdit);
  pParametersPanel.add(Label4);  pParametersPanel.add(le_dtEdit);

  pLeft2Panel = new Panel();
  pLeft2Panel.setLayout (new GridLayout (1,2,4,4));

  pSignalPanel = new Panel();

  pUDPanel = new Panel();
  pUDPanel.setLayout (new GridLayout (4,1,4,4));
  UDUpButton=new Button ("up");  UDLabel=new Label ("",Label.CENTER);  UDDownButton=new Button ("down");
  OKButton=new Button ("OK");
  pUDPanel.add(UDUpButton); pUDPanel.add(UDLabel); pUDPanel.add(UDDownButton); pUDPanel.add(OKButton);

  pLeft2Panel.add (pSignalPanel);
  pLeft2Panel.add (pUDPanel);

  pRightPanel = new Panel ();
  pRightPanel.setLayout (new GridLayout (2,1,4,4));

  pRightPanel1 = new Panel();
  pRightPanel1.setLayout (new GridLayout (6,2,4,4));
  chb_ARU=new Checkbox (""); chb_ARU.setState (true);
  chb_fill=new Checkbox (""); chb_fill.setState (true);
  chb_SURF=new Checkbox (" "); chb_SURF.setState (true);
  chb_RL=new Checkbox (" "); chb_RL.setState (true);
  chb_RR=new Checkbox (" "); chb_RR.setState (true);
  chb_COG=new Checkbox ("Lconst=0"); chb_COG.setState (false);
  lb_xUpButton=new Button ("up");  lb_xLabel=new Label ("dx=10 pixels",Label.CENTER);  lb_xDownButton=new Button ("down");
  lb_tUpButton=new Button ("up");  lb_tLabel=new Label ("amp=10 pixels",Label.CENTER);  lb_tDownButton=new Button ("down");

  pRightPanel1.add(chb_ARU);
  pRightPanel1.add(lb_xUpButton);
  pRightPanel1.add(chb_fill);
  pRightPanel1.add(lb_xLabel);
  pRightPanel1.add(chb_SURF);
  pRightPanel1.add(lb_xDownButton);
  pRightPanel1.add(chb_RL);
  pRightPanel1.add(lb_tUpButton);
  pRightPanel1.add(chb_RR);
  pRightPanel1.add(lb_tLabel);
  pRightPanel1.add(chb_COG);
  pRightPanel1.add(lb_tDownButton);

  pRightPanel2 = new Panel();
  pRightPanel2.setLayout (new GridLayout (3,1,4,4));
  MdlLabel=new Label (",,,: N(/) H() V(/) F()",Label.CENTER);
  ErrorLabel = new Label ("---  OK   ---",Label.CENTER);
  Mdl=new TextArea ("1 1000 2000 30\n0 0 6000 20",10,32);
  pRightPanel2.add (ErrorLabel);
  pRightPanel2.add (MdlLabel);
  pRightPanel2.add (Mdl);

  pLeftPanel.add(pParametersPanel);
  pLeftPanel.add(pRightPanel2);
  pRightPanel.add(pRightPanel1);
  pRightPanel.add(pLeft2Panel);

  add (pLeftPanel);
  add (pRightPanel);

  Iw = pSignalPanel.getGraphics();
  DimIw = pSignalPanel.getSize();

  //formCreate
  kb=1;
  Lmax=Integer.parseInt(le_dxEdit.getText().trim())*
   (Integer.parseInt(le_kppEdit.getText().trim())-1)/2;
  kpv=le_kpv;
  kpp=Integer.parseInt(le_kppEdit.getText().trim());
  dx=Integer.parseInt(le_dxEdit.getText().trim());
  dt=Integer.parseInt(le_dtEdit.getText().trim());
  dts=dt/1000;

  defaultFont = new java.awt.Font("Courier", Font.BOLD, 11);
  canvasFont = new java.awt.Font("Courier", Font.BOLD, 9);
 }

 public void update(Graphics g) {
  //paint (g);
 }

 public void paint (Graphics g) {
  System.out.println ("update main");//!!!
  UDClick (0);
 }

 public void start () {
  repaint ();
 }

 public void UDxClick (int d) {
  strs+=d;
  if (strs<4) strs=4;
  if (strs>20) strs=20;
  lb_xLabel.setText ("dx="+strs+" pixels");
 }

 public void UDamClick (int d) {
  amp+=d;
  if (amp<4) amp=4;
  if (amp>20) amp=20;
  lb_tLabel.setText ("amp="+amp+" pixels");
 }

 public void clearIw () {
  Iw.setColor(Color.white);
  Iw.clearRect (0,0,DimIw.width-1, DimIw.height-1);
  Iw.setColor(Color.black);
  Iw.drawRect (0,0,DimIw.width-1, DimIw.height-1);
 }

 public void putString (String s) {
  ErrorLabel.setText (s);
 }

 public void Pulse(boolean NF, int Extr, int F, double Am) {
  int i,k,am=10;
  //W=null;
  k=(int)(Math.round(1./(F*dts))*Extr / 2 + 2);
  W = new TTrase (k);
  System.out.println ("W length="+k);
  for (i=0;i<W.high();i++) { // 
   if (NF==true)
    W.f[i]=-am*Math.sin(Extr*Math.PI*i/k)*Math.sin(Math.PI*i/k); //-
   else W.f[i]=-am*Math.sin(Extr*Math.PI*i/k)*Math.cos(Math.PI*i/2/k);//
  }
  W.f[W.high()-1]=0;
 }

 static int XX,YY;

 public void moveTo (int x,int y) {
  XX=x; YY=y;
 }

 public void lineTo (Graphics Gr, int x,int y) {
  Gr.drawLine (XX,YY,x,y);
  moveTo (x,y);
 }

 public void DrawTrs (Graphics Im, boolean auto, TTrase Tin,
  int x, int nt, int sct, float Am, boolean f) {
  double ma,m; int a,i;
  ma=-1e9;
  if (auto==true) {
   for (i=0;i<Tin.high();i++) {
    ma=Math.max(ma,Tin.f[i]);
    ma=Math.max(ma,Math.abs(Tin.f[i]));
   }
   m=Math.max(ma,1e-8);
  }
  else m=1;
  a=(int)Math.round((Tin.f[0]/m)*Am);
  moveTo(x+a,nt);
  System.out.println ("Tin.high()="+Tin.high());//!!!
  for (i=0;i<Tin.high(); i++) {
   a=(int)Math.round((Tin.f[i]/m)*Am);
   lineTo(Im,x+a,i*sct+nt);
  }
  if (f==false) return;
  for (i=0;i<Tin.high(); i++) {
   a=(int)Math.round((Tin.f[i]/m)*Am);
   if (a>0) {
    moveTo(x,i*sct+nt);
    lineTo(Im,x+a,i*sct+nt);
   }
  }
 }

 public void UDClick (int d) {
  int n=0;
  UDPosition+=d;
  if (UDPosition<0) UDPosition=0;
  if (UDPosition>6) UDPosition=6;
  UDLabel.setText (" ("+UDPosition+")");
  switch (UDPosition) {
   case 0: kex=2; NF=false; n=15; break;
   case 1: kex=3; NF=false; n=10; break;
   case 2: kex=4; NF=false; n=5; break;
   case 3: kex=5; NF=false; n=0; break;
   case 4: kex=3; NF=true; n=10; break;
   case 5: kex=4; NF=true; n=5; break;
   case 6: kex=5; NF=true; n=0; break;
  }
  Pulse(NF,kex,25,1);
  DimIw = pSignalPanel.getSize();
  clearIw();
  DrawTrs(Iw,false,W,DimIw.width/2,n,1,-amp,true);
 }

 float [][] Cells;
 int kbCount;
 public boolean getMemoArray (String s) {
  int i,j;
  String c="";
  kbCount=0;
  boolean get=false;
  float f;
  s=s+' ';
  for (i=0; i<s.length(); i++) {
   switch (s.charAt(i)) {
    case '\r':
    case '\n':
    case '\t':
    case ' ': get=true; break;
    default: c=c+s.charAt(i); break;
   }
   if (get==true) {
    if (c.trim().length()>0) {
     kbCount++;
     System.out.println (""+c);//!!!
     try { f=Float.valueOf(c.trim()).floatValue(); }
     catch (java.lang.NumberFormatException ee) { return false; }
     c="";
    }
    get=false;
   }
  }
  System.out.println ("kbCount="+kbCount);//!!!
  if ((kbCount<8) || (kbCount%4!=0) || ( kbCount<(kb+1)*4 )) return false;
  kbCount/=4;
  Cells = new float[kbCount][4];
  c="";
  int row,col;
  row=0; col=0;
  for (i=0; i<s.length(); i++) {
   switch (s.charAt(i)) {
    case '\r':
    case '\n':
    case '\t':
    case ' ': get=true; break;
    default: c=c+s.charAt(i); break;
   }
   if (get==true) {
    if (c.trim().length()>0) {
     try { f=Float.valueOf(c.trim()).floatValue(); }
     catch (java.lang.NumberFormatException ee) { return false; }
     Cells[row][col++]=f;
     if (col==4) { row++; col=0; }
     c="";
    }
    get=false;
   }
  }
  col=4;
  System.out.println("row,col="+row+","+col);//!!!
  for (i=0; i<row; i++) {
   if ((i>0) && (i<row-1) && (Cells[i][0]!=Cells[i-1][0]+1)) return false;
   if ((i==row-1) && (Cells[i][0]!=0)) return false;
   for (j=0; j<col; j++) {
    if ((i==row-1) && (j==1) && (Cells[i][j]!=0)) return false;
    if (Cells[i][j]<0) return false;
   }
  }
  return true;
 }

 public void doTitles () {
  System.out.println("doTitles in");//!!!
  int i,j,sx,gx,mx,offset,dcdp,xs,xr,dpp,dpv,dsgm;
  //E=null;
  HB.F4[0]=(0);
  HB.F4[1]=(1);
  HB.F4[2]=(1);HB.F2[0]=(kpp);//
  HB.F2[6]=(1);HB.F2[8]=(1);HB.F2[21]=(1);
  HB.F2[2]=(int)Math.round(dt*1000);
  HB.F2[4]=(kdt);//ns
  /*
  System.out.println("E size="+(kpp*kpv));//!!!
  E = new TTitles (kpp*kpv);
  */
  dpp=(int)Math.round(dx); dpv=dpp; dsgm=dpv;
  xs=((kpp-1)/2)*dpp;
  xr=0;
  for (i=0; i<kpv; i++) {
   sx=xs+i*dpv;
   for (j=0; j<kpp; j++) {
    gx=xr+j*dpp+i*dsgm;
    mx=(sx+gx)/2;
    offset=gx-sx;
    dcdp=dpp/2;
    /*
    E.E[j+i*kpp].F41[0]=(j+i*kpp+1);
    E.E[j+i*kpp].F41[1]=(j+i*kpp+1);
    E.E[j+i*kpp].F41[2]=(i+1);
    E.E[j+i*kpp].F41[3]=(j+1);
    E.E[j+i*kpp].F41[4]=(i+1);
    E.E[j+i*kpp].F41[5]=(mx / dcdp +1);
    E.E[j+i*kpp].F21[0]=(1);
    E.E[j+i*kpp].F21[1]=(1);
    E.E[j+i*kpp].F21[2]=(1);
    E.E[j+i*kpp].F21[3]=(1);
    E.E[j+i*kpp].F42[0]=(offset);
    E.E[j+i*kpp].F43[0]=(sx);
    E.E[j+i*kpp].F43[2]=(gx);
    E.E[j+i*kpp].F23[13]=HB.F2[4];
    E.E[j+i*kpp].F23[14]=HB.F2[2];
    E.E[j+i*kpp].F23[47]=sx / dpv+1;
    E.E[j+i*kpp].F23[49]=gx / dpp+1;
    */
   }
  }
  System.out.println("doTitles out");//!!!
 }

 public void CalcSURF () { //  
  System.out.println("CalcSURF in");//!!!
  int i,j,k;
  double l,t,am,v;
  v=Cells[0][2];
  Pulse(NF,kex,(int)Cells[0][3],(float)0.5);
  for (i=0; i<D.high(); i++) {
   l=-Lmax+i*dx;
   am=dx/Math.max(Math.abs(l),dx);
   t=Math.abs(l)/v;
   k=(int)Math.round(t/dts);
   for (j=0;j<W.high();j++) {
    if (k+j<D.t[i].high()) D.t[i].f[k+j]=D.t[i].f[k+j]+W.f[j]*am;
   }
  }
  System.out.println("CalcSURF out");//!!!
 }

 public void CalcRL () { //  
  System.out.println("CalcRL in");//!!!
  int i,j,k,n,ndt;
  double h,v,s,l,t,sina,cosa,a,da,am,al;
  boolean Next;
  //G = new TPointArray ();
  Next=false;
  for (k=1;k<=kb;k++) {
   G = new TPointArray (); //  G=nil     k
   Pulse(NF,kex,(int)Cells[k][3],1);
   am=Ko[k-1].o;
   a=0;sina=0;da=Math.PI/360;
   while (a<Math.PI/2) {
    l=0;t=0;s=0;
    for (j=1;j<=k;j++) {
     if (j==1) sina=Math.sin(a);
     else sina*=Cells[j-1][2]/Cells[j-2][2];
     if (sina>=1) {
      a-=da;
      da/=2;
      Next=true;
      break;
     }
     else Next=false;
     cosa=Math.sqrt(1-sina*sina);
     v=Cells[j-1][2];
     h=Cells[j-1][1];
     l+=2*(h*sina/cosa);
     s+=2*(h/cosa);
     t+=2*(h/cosa)/v;
    }
    if (Next==true) continue;
    //setlength(G,length(G)+1);
    System.out.println ("Added: "+l+","+t+","+(j-1));//!!!
    G.Add (l,t,j-1); //G[high(G)].l:=l; G[high(G)].t:=t; G[high(G)].a:=j-1;
    if (l>Lmax) break;
    a+=da;
   }
   n=0;
   l=0;
   j=0;
   System.out.println ("G.size()="+G.length());//!!!
   while ((l>=G.getL(n))&&(l<G.getL(n+1))) {
    ndt=(int)Math.round(((l-G.getL(n))*(G.getT(n+1)-G.getT(n))/(G.getL(n+1)-G.getL(n))+G.getT(n))/dts);
    al=5*dx/Math.max(Math.abs(l),5*dx);//
    for (i=0;i<W.high();i++)
     if (ndt+i<D.t[0].high())
      D.t[D.high()/2+j].f[ndt+i]=D.t[D.high()/2+j].f[ndt+i]+W.f[i]*am*al;
    if (j!=0) D.t[D.high()/2-j]=D.t[D.high()/2+j];
    j++;l+=dx;
    if (j>D.high()/2) break;
    while (l>=G.getL(n+1)) n++;
    if (n==G.length()-1) break;
   }
   G=null;
  }
  System.out.println("CalcRL out");//!!!
 }

 public void CalcRR () { //  
  System.out.println("CalcRR in");//!!!
  int i,j,k,ndt;
  double sina,cosa,v,vg,vm,h,l,t,s,lt,ll,am,al;
  if ((Lmax==0)||(chb_COG.getState()==true)) return;
  for (i=1;i<=kb;i++) {
   if (Cells[i-1][2]>Cells[i][2]) continue;
   Pulse(NF,kex,(int)Cells[i][3],0.75);
   am=Ko[i-1].o;
   l=0; t=0; s=0; sina=0; vm=Cells[0][2];
   for (j=i; j>=1; j--) {
    if (j==i) sina=Cells[j-1][2]/Cells[j][2];
    else sina*=Cells[j-1][2]/Cells[j][2];
    if (sina>=1) continue;
    cosa=Math.sqrt(1-sina*sina);
    v=Cells[j-1][2];
    vm=Math.max(vm,v);
    h=Cells[j-1][1];
    l+=2*(h*sina/cosa);
    s+=2*(h/cosa);
    t+=2*(h/cosa)/v;
   }
   vg=Cells[i][2];
   if (vm>vg) continue;
   lt=Lmax/vg/Lmax;
   k=0;
   ll=0;
   while (ll<l) {
    k++;ll+=dx;
    if (ll>2*Math.round(Lmax)) break;
   }
   while ( (ll>=l) && (ll<(l+Lmax)) && (k<(D.high()/2+1)) ) {
    ndt=(int)Math.round(((ll-l)*lt+t)/dts);
    al=2*dx/Math.max(Math.abs(ll),2*dx);
    for (j=0;j<W.high();j++)
     if ((ndt+j)<D.t[k].high())
      D.t[D.high()/2+k].f[ndt+j]+=+W.f[j]*am*al;
    D.t[D.high()/2-k]=D.t[D.high()/2+k];
    k++; ll+=dx;
   }
  }
  System.out.println("CalcRR out");//!!!
 }

 public void CalcCOG () {
  System.out.println("CalcCOG in");//!!!
  int i,nt,k,sx,gx,mx,offset,dcdp,xs,dpp,dpv;
  TTrase L;
  nt=D.high()/2;
  L = new TTrase (D.t[nt].high()+1);
  for (int il=0; il<D.t[nt].high(); il++) //L:=D[nt];
   L.f[il]=D.t[nt].f[il];
  D = new TSgm (kpv);
  for (int l=0; l<kpv; l++) {
   try {
    D.t[l]=new TTrase(L.high()+1);
   }
   catch (java.lang.ArrayIndexOutOfBoundsException e) {
    break;
   }
  }
  /*
  E = new TTitles (kpv);
  */
  for (i=0;i<D.high();i++) //D[i]:=L;
  for (int j=0; j<D.t[i].high();j++)
   try {
    D.t[i].f[j]=L.f[j];
   }
   catch (java.lang.ArrayIndexOutOfBoundsException e) {
    break;
   }
  //L=null;
  dpp=(int)Math.round(dx); dpv=dpp;
  xs=((kpp-1)/2)*dpp;
  for (k=0;k<=kpv-1;k++) {
   sx=xs+k*dpv;
   gx=sx; mx=sx; offset=0; dcdp=dpp/2;
   /*
   E.E[k].F41[0]=(k+1);
   E.E[k].F41[1]=(k+1);//trr
   E.E[k].F41[2]=(k+1);//fldr  FFID
   E.E[k].F41[3]=(nt+1);//trf
   E.E[k].F41[4]=(k+1);//sp
   E.E[k].F41[5]=(mx/dcdp +1);//cdp
   E.E[k].F21[0]=(1);
   E.E[k].F21[1]=(1);
   E.E[k].F21[2]=(1);
   E.E[k].F21[3]=(1);
   E.E[k].F42[0]=(offset);
   E.E[k].F43[0]=(sx);//sx
   E.E[k].F43[2]=(gx);//gx
   E.E[k].F23[13]=HB.F2[4];//ns
   E.E[k].F23[14]=HB.F2[2];//dt
   E.E[k].F23[47]=sx/dpv+1;//PKs
   E.E[k].F23[49]=gx/dpp+1;//PKg
   */
  }
  System.out.println("CalcCOG out");//!!!
 }

 public void PlotMdl () {
  System.out.println("PlotMdl in");//!!!
  int i,m,zm,z;
  String s;
  m=500;zm=250000;
  if (Zmax<=500) { m=1;zm=500; }
  if ((Zmax>500)&&(Zmax<=1000)) { m=2; zm=1000; }
  if ((Zmax>1000)&&(Zmax<=5000)) { m=10; zm=5000; }
  if ((Zmax>5000) && (Zmax<=10000)) { m=20;zm=10000; }
  if ((Zmax>10000)&&(Zmax<=50000)) { m=100;zm=50000; }
  if ((Zmax>50000)&&(Zmax<=100000)) { m=200;zm=100000; }
  System.out.println ("Zmax="+Zmax);//!!!
  s="";
  ff.Im().setFont (defaultFont);
  ff.Im().setColor (Color.black);
  int ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,WM/2-ww/2,10);
  ff.Im().setFont (canvasFont);
  for (i=0;i<=4;i++) {
   s=""+i*2000;
   ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
   ff.Im().drawString (s,60+i*50-ww/2,35);
  }
  s="V /";
  ff.Im().drawString (s,WM-85,35);
  for (i=0;i<=5;i++) {
   s=""+(i*(zm/5));
   ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
   ff.Im().drawString (s,45-ww,i*(zm/5/m)+53);
  }
  s="Z ";
  ff.Im().drawString (s,20,ff.DimIm().height-12);
  for (i=0;i<=9;i++) {
   moveTo(i*25+60,50);
   lineTo(ff.Im(),i*25+60,zm/m +70);
  }
  for (i=0;i<=5;i++) {
   moveTo (50,i*(zm/5/m)+60);
   lineTo (ff.Im(),295,i*(zm/5/m)+60);
  }
  ff.Im().setColor (Color.red); //Im.Canvas.Pen.Width:=3;
  z=0;
  moveTo (60+(int)Cells[0][2]/40,60);
  for (i=1;i<=kb;i++) {
   System.out.println ("cells["+(i-1)+",1]="+Cells[i-1][1]);//!!!
   z+=(int)Cells[i-1][1]/m;
   lineTo(ff.Im(),60+(int)Cells[i-1][2]/40,z+60);
   lineTo(ff.Im(),60+(int)Cells[i][2]/40,z+60);
  }
  lineTo(ff.Im(),60+(int)Cells[kb][2]/40,zm/m+60);
  System.out.println("PlotMdl out");//!!!
 }

 public void PlotSgm () {
  System.out.println("PlotSgm in");//!!!
  int i,n,m;
  String s;
  m=(int)Math.floor(Tmax/0.2);
  n=(int)Math.round(0.2/dts);
  ff.Im().setFont (defaultFont);
  ff.Im().setColor (Color.black);
  s="";
  int ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,WM+WS/2-25-ww/2,10);
  ff.Im().setFont (canvasFont);
  for (i=0;i<D.high();i++) {
   DrawTrs(ff.Im(),chb_ARU.getState(),D.t[i],ns+i*strs,nt,sct,amp,chb_fill.getState());
   moveTo(ns+i*strs,nt-5);
   lineTo(ff.Im(),ns+i*strs,nt);
  }
  for (i=0;i<=m;i++) {
   s=""+(i*200);
   if (i%5==0) ff.Im().setColor (Color.red);
   else ff.Im().setColor (Color.black);
   moveTo(ns-10,i*n+50);
   lineTo(ff.Im(),ns+D.high()*strs+10,i*n+50);
   ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
   ff.Im().drawString (s,ns-15-ww,i*n+43);
  }
  s="T ";
  ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,408-ww,nt+10+m*n);
  s=""+Math.round(-Lmax);
  if (chb_COG.getState()==true) s=""+Math.round(Lmax);
  ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,420-ww/2,30);
  if (chb_COG.getState()==false) {
   s=""+Math.round(Lmax);
   ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
   ff.Im().drawString (s,420+(kpp-1)*strs-ww/2,30);
  }
  else {
   s=""+Math.round(Lmax+(kpv-1)*dx);
   ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
   ff.Im().drawString (s,420+(kpv-1)*strs-ww/2,30);
  }
  s="0";
  if (chb_COG.getState()==true) s="";
  ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,420+(kpp/2)*strs-ww/2,30);
  s="X ";
  ww=getFontMetrics(ff.Im().getFont()).stringWidth(s);
  ff.Im().drawString (s,D.high()*strs+20,30);
  System.out.println("PlotSgm out");//!!!
 }

 public void Plot () { //   
  System.out.println("Plot in");//!!!
  HMS=kdt+80;
  WM=375;
  if (chb_COG.getState()==false) WS=strs*(kpp+9)+50;
  else WS=strs*(kpv+9)+50;
  HMS=Math.max(HMS,900);
  System.out.println("WM,WS,HMS="+WM+","+WS+","+HMS);//!!!
  ff = new Frame1 ("");
  ff.setSize (WM+WS,HMS); //Width:=WM+WS; Height:=HMS;
  ff.setDimIm ();
  ff.show();
  ff.clearIm();
  ff.paint(ff.Im());
//  PlotMdl();  PlotSgm();

  System.out.println("Plot out");//!!!
 }

 public void sb_CalcClick () {
  System.out.println ("sb_CalcClick");//!!!
  int i,j;
  double t;
  int []fields = {0,0,0,0};
  try {
   fields[0]=Integer.parseInt(le_kbEdit.getText().trim());
   fields[1]=Integer.parseInt(le_dxEdit.getText().trim());
   fields[2]=Integer.parseInt(le_kppEdit.getText().trim());
   fields[3]=Integer.parseInt(le_dtEdit.getText().trim());
  }
  catch (java.lang.NumberFormatException ee) {
   putString ("   !");
   return;
  }
  for (i=0; i<4; i++) {
   if (fields[i]<1) {
    putString ("   !");
    return;
   }
  }
  kb=fields[0];
  dx=fields[1];
  kpp=fields[2];
  dt=fields[3];
  if (kpp%2==0) {
   kpp++; le_kppEdit.setText(""+kpp);
  }
  dts=dt/1000;
  if (getMemoArray (Mdl.getText())==false) {
   putString ("  N H V F! . ");
   return;
  }
  putString ("---  OK   ---");
  Ko=null;
  System.out.println ("kb="+kb);//!!!
  Ko = new Tnu [kb];
  for (int l=0; l<kb;l++) {
   Ko[l]=new Tnu();
  }
  t=0;
  Lmax=(kpp-1)*dx/2;
  Zmax=0;
  D=null;
  for (i=1;i<=kb;i++) {
   Ko[i-1].o=(Cells[i-1][2]-Cells[i][2])/(Cells[i-1][2]+Cells[i][2]);//(i);
   Ko[i-1].p=2*Cells[i-1][2]/(Cells[i-1][2]+Cells[i][2]);
   t+=Cells[i-1][1]/Cells[i-1][2];
   Zmax+=Cells[i-1][1];
  }
  Zmax=Math.round(Zmax+Zmax/5.);
  Zmax=Math.round(Zmax/100.+1.)*100;
  Tmax=Lmax/Cells[kb][2]+2*t;//+0.2;
  Tmax=(Math.round(Tmax/0.2)+2)*0.2;
  kdt=(int)Math.round(Tmax/dts)+1;
  System.out.println ("kpp,kdt="+kpp+","+kdt);//!!!
  D = new TSgm (kpp);
  for (int l=0; l<kpp; l++) {
   D.t[l]=new TTrase(kdt+1);
  }
  doTitles ();
  if (chb_SURF.getState()==true) CalcSURF();
  if (chb_RL.getState()==true) CalcRL();
  if (chb_RR.getState()==true) CalcRR();
  if (chb_COG.getState()==true) CalcCOG();
  Plot();
 }

 public boolean action (Event evt, Object obj) {
  System.out.println ("action");//!!!
  if(evt.target instanceof Button) {
   if(evt.target.equals(OKButton)) {
    sb_CalcClick ();
   }
   else if(evt.target.equals(UDUpButton)) {
    UDClick (1);
   }
   else if(evt.target.equals(UDDownButton)) {
    UDClick (-1);
   }
   else if(evt.target.equals(lb_xUpButton)) {
    UDxClick (2);
   }
   else if(evt.target.equals(lb_xDownButton)) {
    UDxClick (-2);
   }
   else if(evt.target.equals(lb_tUpButton)) {
    UDamClick (2);
   }
   else if(evt.target.equals(lb_tDownButton)) {
    UDamClick (-2);
   }
  }
  return true;
 }

 public void destroy () {
  System.out.println ("destroy");//!!!
  Iw.dispose ();
 }

}